#!/usr/local/bin/perl

# FIAB-Board (Foolishly Implemented Again Bulletin-Board)
# By Tatsu 2007,2010,2011,2016,2017
# Version 1.1.0

use strict;

#CGIѥ饤֥
require "lib/cgi-lib.pl";
#
require "lib/config.cgi";
#̥֥롼
require "lib/bbslib.pl";

#ե⥰Х
my @index = ();
my $maxThreads = 0;
my $prevStart = -1;
my $nextStart = -1;

my $lockObj;

our %in;

#ᥤ롼

#ꥯȤ᤹롣
&ReadParse(*in);

#ɽϥå
my $startThread = $in{'start'};
my $permaView = $in{'permaview'};
my $permaViewNo = $in{'no'};

if ($config::staticMode == 1) {
	$config::useFolding = 0;
}

#ϢνΥåԤ
$lockObj = my_flock();
if (!$lockObj) {
	putNeedWaitPage();
	exit(1);
}

readIndex();

if (length($permaView) == 0){

	#åɥӥ塼
	if (length($startThread) == 0){
		$startThread = $maxThreads - 1;
	}

	#ΥڡؤΥ󥯤Ϥ뤫
	if ($startThread < ($maxThreads - 1)){
		$nextStart = $startThread + $config::threadsOnPage;
		if ($nextStart >= $maxThreads){
			$nextStart = $maxThreads - 1;
		}
	}

	#ΥڡؤΥ󥯤Ϥ뤫
	if (($startThread - $config::threadsOnPage) > -1){
		$prevStart = $startThread - $config::threadsOnPage;
	}
	showThreadView();
}else{
	showPermanentView($permaViewNo);
}

#λˤĤå롣
my_funlock($lockObj);

#ǥåեɤ߹ߤޤ
sub readIndex {
	my (@argv) = @_;
	my $readText;

	if (open(FILE,"<data/index.dat")) {
		#flock(FILE,2);

		while(<FILE>){
			$readText = $_;
			chomp($readText);
			
			$index[$maxThreads] = $readText;
			$maxThreads++;
		}

		#flock(FILE,8);
		close(FILE);
	}

}

#ʣΥåɽ
sub showThreads {
	my (@argv) = @_;

	my $i;
	my $first = ${argv[0]};
	my $result;
	my $final;

	$final = $config::threadsOnPage;
	for ($i = 0;$i < $final;$i++){
		if (($first - $i) < 0){
			last;
		}

		$result = showSingleThread($index[$first - $i], $first - $i + 1);
		if ($result == 1) {
			$final++;
		}

	}
}

#ñΥåɽ
sub showSingleThread {
	my (@argv) = @_;
	my $thread = ${argv[0]};
	my $viewNo = ${argv[1]};	#-1ΤȤϥåֹ򵤤ˤʤPermalinkɽ⡼

	my $fileName;
	my $date;
	my $auther;
	my $password;
	my $title;
	my $content;
	my $mail;
	my $url;
	my $status;
	my $addr;
	my $agent;
	my $showComments = 0;	#ɽȿ
	my $resPermit = 0;	#쥹ݥ󥹵ľ(0: 1:ƿã 2:ڤ)
	my $res;	#쥹ݥֹ(0-)
	my $lastValidRes;	#Ǹɽǽʥ쥹ݥֹ
	my $lastDate;		#Ǹɽǽʥ쥹ݥ󥹤
	my $lastAuther;
	my $lastPassword;
	my $lastTitle;
	my $lastContent;
	my $lastMail;
	my $lastUrl;
	my $lastStatus;
	my $lastAddr;
	my $lastAgent;
	my $showCount = 0;;
	my $limitDayStr;	#åɤ˥쥹ݥ󥹤񤱤ǽ
	my $wroteDay = "";	#ƥȤ񤤤
	my $isFirst = 1;
	my $showFolded = 0;
	my $foldCount = 0;
	my $result = 1;
	my $noPermit = 0;	#̤Ĥν񤭹߿

	#
	my @today = localtime(time);
	my $todayStr = sprintf("%04d/%02d/%02d",$today[5] + 1900,$today[4]+1,$today[3]);

	#åɤΥեɤ߹ɽޤ
	$showComments = 0;
	if (open(FILE,"<data/${thread}.dat")) {
		#flock(FILE,2);

		#å
		print "<div class='thread'>\n";

		#åֹ
		if ($viewNo > -1){
			print "<p class='No'>\n";
			printf "No.%d<br>\n",$viewNo;
			print "</p>\n\n";
		}

		$res = 0;
		$lastValidRes = -1;
		while(1){

			$date = readline *FILE;
			if (eof(FILE)){
				last;
			}
			if ($wroteDay eq ""){
				#񤭹롣
				$wroteDay = substr($date,0,10);

				if ($config::commentLimitDays > 0){
					$limitDayStr = addDate(
						substr($wroteDay,0,4),
						substr($wroteDay,5,2) - 1,
						substr($wroteDay,8,2),
						$config::commentLimitDays);
				}
#					print $todayStr;
#					print "\n";
#					print $wroteDay;
#					print "\n";
#					print $limitDayStr;
#					print "\n";
			}

			$auther = readline *FILE;
			if (eof(FILE)){
				last;
			}

			$mail = readline *FILE;
			if (eof(FILE)){
				last;
			}

			$url = readline *FILE;
			if (eof(FILE)){
				last;
			}

			$status = readline *FILE;
			if (eof(FILE)){
				last;
			}

			$addr = readline *FILE;
			if (eof(FILE)){
				last;
			}

			$agent = readline *FILE;
			if (eof(FILE)){
				last;
			}

			$password = readline *FILE;
			if (eof(FILE)){
				last;
			}

			$title = readline *FILE;
			if (eof(FILE)){
				last;
			}
			
			$content = readline *FILE;

			chomp($date);
			chomp($auther);
			chomp($mail);
			chomp($url);
			chomp($status);
			chomp($addr);
			chomp($agent);
			chomp($password);
			chomp($title);
			chomp($content);

			#ơ0(ɽ)λɽ롣
			if ($status eq "0"){
				$lastValidRes = $res;
				$lastDate = $date;
				$lastAuther = $auther;
				$lastPassword = $password;
				$lastTitle = $title;
				$lastContent = $content;
				$lastMail = $mail;
				$lastUrl = $url;
				$lastStatus = $status;
				$lastAddr = $addr;
				$lastAgent = $agent;

				#ǽ餫Ǹ夫ѡޥͥȥ󥯤ξɽԤ
				if (($isFirst != 0) || (eof(FILE)) || ($viewNo < 0) || ($config::useFolding == 0)){
					#ǸǤġά줿쥹ݥ󥹤˥åɽؤΥ󥯤Ĥ롣
					if (eof(FILE) && ($foldCount > 0)){
						print "<p class='Permalink'>\n";
						printf "%dΥ쥹ݥ󥹤άƤޤ<br>",$foldCount;
						printf "<a href=\"%sbbs.cgi?permaview=1&amp;no=%d\" >٤ɽȤϤΥ󥯤򤿤ɤäƤ</a>",$config::basedir,${thread};
						print "</p>\n";
						printf "<hr class='articleBorder'>\n\n";
						$showFolded = 1;
					}

					showArticle($res,$title,$date,$auther,$mail,$url,$content,$agent);

					if ($config::staticMode != 1) {
						print "<p>\n";
						printf "<a href=\"%sdel.cgi?t=%d&amp;r=%d\">Ƥ</a>",$config::basedir,$thread,$res;
						print "</p>\n";
					}
					printf "<hr class='articleBorder'>\n\n";
					$showCount++;
				}else{
					$foldCount++;
				}

				$showComments++;
				$isFirst = 0;
			}
			if ($status eq "1"){
				#̤ĤΥȤϷȤ롣
				$showComments++;
				$noPermit++;
			}

			if (eof(FILE)){
				last;
			}
			$res++;
		}
		
		if ($config::useFolding != 0) {
			if (($res > 1) && ($showCount < 2)) {
				#ʣΥ쥹ˤ⤫餺Ǹ夬ɽƤʤ
				showArticle($lastValidRes,$lastTitle,$lastDate,$lastAuther,$lastMail,$lastUrl,$lastContent,$lastAgent);

				if ($config::staticMode != 1) {
					print "<p>\n";
					printf "<a href=\"%sdel.cgi?t=%d&amp;r=%d\">Ƥ</a>",$config::basedir,$thread,$lastValidRes;
					print "</p>\n";
				}
				printf "<hr class='articleBorder'>\n\n";
				$showCount++;
			}
		}

		if ($showComments > 0){
			#祳ȿåԤɤ
			if ($config::maxComments > 0){
				#祳ȿå
				if ($showComments < ($config::maxComments + 1)){
					#祳ȿʲξֿǽȤ롣
					$resPermit = 0;
				}else{
					#祳ȿã쥹ݥ󥹤Ǥʤ褦ˤ롣
					$resPermit = 1;
				}
			}else{
				$resPermit = 0;
			}
			
			if ($config::commentLimitDays > 0){
				#Ѥƽ񤭹ߤĤʸ夫ɤȽꤹ롣
				if ($todayStr gt $limitDayStr){
					$resPermit = 2;
				}
			}

			if ($config::staticMode != 1) {
				print "<p class=\"threadOperation\">\n";
				if ($config::writeMode == 1) {
					if ($noPermit > 0) {
						print "ͤθԤΥȤޤ";
						print "<br><br>";
					}
				}
				#ֿ
				if ($resPermit == 0){
					printf "<a href=\"%s\">Υåɤֿ</a>\n",$config::basedir."res.cgi?t=".$thread;
				}elsif ($resPermit == 1){
					#祳ȿã쥹ݥ󥹤Ǥʤ褦ˤ롣
					printf "Υåɤκƿãޤ";
				}elsif ($resPermit == 2){
					#ڤˤʤä쥹ݥ󥹤Ǥʤ褦ˤ롣
					printf "ΥåɤΥ쥹ݥ󥹴¤ãޤ";
				}
				print "<br>";
				
				#ѡޥ
				if ($viewNo > -1){
					#ѡޥɽؤΥ
					printf " <a href=\"%sbbs.cgi?permaview=1&amp;no=%d\" >[Permalink]</a>",$config::basedir,${thread};
				}
				print "</p>\n";
			}

		}else{
			print "<p>\n";
			print "ΥåɤϴԤθԤǤ\n";
			print "</p>\n";
		}

		print "</div>\n\n";
		print "<hr class='threadSeparator'>\n\n";

		#flock(FILE,8);
		close(FILE);

		#1åɤäʳǿƥȤ񤤤ꥻåȤ롣
		$wroteDay = "";
		
		$result = 0;
	}
#		print $index[$first - $i];
#		print "<br>\n";

	return $result;
}

#ꤷȤʤǯûyyyy/mm/dd֤
#addDate(ǯ(),(0-11:̾η-1),(1-31),û)
sub addDate {
	my @argv = @_;
	my $year = $argv[0];
	my $month = $argv[1];
	my $day = $argv[2];
	my @monthDays = (31,28,31,30,31,30,31,31,30,31,30,31);
	my $days;
	my $add = $argv[3];

#	printf "%04d/%02d/%02d\n",$year,$month + 1,$day;

	while($add > 0){
		$day = $day + $add;

		$days = $monthDays[$month];
		#뤦ǯν
		if (($month == 1) && 
			((($year % 4 == 0) && ($year % 100 != 0)) || ($year % 400 == 0))
		){
			$days++;
		}

		if ($day <= $days){
			$days = 0;
			last;
		}else{
			$add = $day - $days;
			$day = 0;
			$month++;
			#ǯޤν
			if ($month > 11){
				$month = 0;
				$year++;
			}
		}
	}
#	printf "%04d/%02d/%02d\n",$year,$month + 1,$day;
	return sprintf("%04d/%02d/%02d",$year,$month + 1,$day);

}

#BBSΥݥꥷɽ롣
sub putPolicy {
	print "<div class='thread'>\n";
	print "<p class='article'>\n";
	if ($config::writeMode == 1){
		print "񤭹ߤϴͤγǧ˸ޤ<br>\n";
	}else{
		print "񤭹ߤ¨ޤ<br>\n";
	}
	if ($config::maxComments > 0){
		print "1åɤֿǤ${config::maxComments}ޤǤǤ<br>\n";
	}
	if ($config::commentLimitDays > 0){
		print "åɤֿǤ֤ϥåɤΩäƤ${config::commentLimitDays}ޤǤǤ<br>\n";
	}
	print "</p>\n";
	print "</div>\n";
}

#إåζʬϤ롣
sub putCommonHeader {
	my @argv = @_;

	print "Content-type: text/html;charset=EUC-JP\n";
	#print "Cache-Control: no-cache\n";
	print "Pragma: no-cache\n";
	print "X-UA-Compatible: IE=edge\n";
	print "\n";

	print <<"EOM";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=EUC-JP">
<meta http-equiv="content-script-type" content="text/javascript">
<meta http-equiv="content-style-type" content="text/css">
<meta http-equiv="Content-Language" content="ja">
<title>$argv[0]</title>
EOM

	if (length($argv[1]) > 0){
		printf "<link rel=\"stylesheet\" type=\"text/css\" href=\"%s\" media='screen,tv,projection,print'>\n",$argv[1];
	}

	if (length($argv[2]) > 0){
		printf "<link rel=\"stylesheet\" type=\"text/css\" href=\"%s\" media='handheld'>\n", $argv[2];
	}

}

sub showThreadView {
	#餬ڡɽ
	putCommonHeader($config::bbsname, $config::stylesheet, $config::handheldCSS);

	#linkˤڡ
	if ($maxThreads > 0) {
		printf "<link rel=\"Last\" href=\"%sbbs.cgi?start=%d\">\n",$config::basedir,$maxThreads - 1;
	}
	if ($prevStart > -1) {
		printf "<link rel=\"Prev\" href=\"%sbbs.cgi?start=%d\">\n",$config::basedir,$prevStart;
	}

	if ($nextStart > -1) {
		printf "<link rel=\"Next\" href=\"%sbbs.cgi?start=%d\">\n",$config::basedir,$nextStart;
	}
	if ($config::webPageUrl ne ""){
	print "<link rel=\"Top\" href=\"${config::webPageUrl}\">\n";
	}
	printf "<link rel=\"Up\" href=\"%sbbs.cgi\">\n",$config::basedir;
	if ($config::useRSS > 0) {
		printf "<link rel=\"alternate\" type=\"application/rss+xml\" title=\"RSS\" href=\"%s\">\n", $config::rssUrl;
	}

	print <<"EOM";
</head>
<body>
<h1><a id="top">${config::bbsname}</a></h1>
EOM

	#ʸ
	print "<p class='guide'>\n";
	print "${config::guide}\n";
	print "</p>\n";

	#ޥ
	print "<p class='topCommand'>\n";
	if ($config::staticMode != 1) {
		print "<a href=\"${config::basedir}write.cgi\" accesskey=\"W\">񤭹(W)</a> ";
	}
	if ($config::webPageUrl ne ""){
		print "<a href=\"${config::webPageUrl}\" accesskey=\"R\">ȥåץڡ(R)</a> ";
	}else{
		print "ȥåץڡ(R) ";
	}
	if ($config::staticMode != 1) {
		if ($config::useRSS > 0) {
			printf "<a href=\"%s\">RSS</a> ", $config::rssUrl;
		}
		if ($config::helpPageUrl ne ""){
			print "<a href=\"${config::helpPageUrl}\" accesskey=\"H\">إ(H)</a>";
		}else{
			print "إ(H)";
		}
	}
	print "<br>\n";
	print "</p>\n\n";

	if ($config::staticMode != 1) {
		if ($config::useLastEntry != 0){
			my $latest = readLatest();
			if ($latest ne ""){
				print "<p class='latest'>\n";
				printf "Last entry:%s",$latest;
				print "</p>\n\n";
			}
		}
	}

	#åɽ
	showThreads($startThread);

	if ($config::showPolicy == 1){
		if ($config::staticMode != 1) {
			putPolicy();
		}
	}

	#ڡ󥰥
	print "<p class='navigation'>\n";
	if ($prevStart > -1) {
		printf "<a href=\"%sbbs.cgi?start=%d\" accesskey=\"P\">&lt;&lt; Υڡ(P)</a> ",$config::basedir,$prevStart;
	}else{
		print "&lt;&lt; Υڡ(P) "
	}

	printf " <a href=\"%sbbs.cgi\" accesskey=\"T\">ǿΥڡ(T)</a> ",$config::basedir;
	printf " <a href=\"#top\" accesskey=\"O\">ڡƬ(O)</a> ";

	if ($nextStart > -1) {
		printf " <a href=\"%sbbs.cgi?start=%d\" accesskey=\"N\">Υڡ(N) &gt;&gt;</a>",$config::basedir,$nextStart;
	}else{
		print " Υڡ(N)  &gt;&gt;";
	}
	print "<br>\n";
	print "</p>\n\n";

if ($config::staticMode != 1) {
	print <<"EOM";
<form method="POST" action="${config::basedir}admin.cgi" class="adminForm">
<p>
<span class='formDescription'>ѥѥɡ</span><input type="password" name="a">
<input type="submit" value="">
</p>
</form>
EOM
}
	putFooter();

}

sub showPermanentView {
	#餬ڡɽ
	putCommonHeader($config::bbsname, $config::stylesheet, $config::handheldCSS);

#	if ($maxThreads > 0) {
#		printf "<link rel=\"Last\" href=\"%sbbs.cgi?start=%d\">\n",$config::basedir,$maxThreads - 1;
#	}
#	if ($prevStart > -1) {
#		printf "<link rel=\"Prev\" href=\"%sbbs.cgi?start=%d\">\n",$config::basedir,$prevStart;
#	}

#	if ($nextStart > -1) {
#		printf "<link rel=\"Next\" href=\"%sbbs.cgi?start=%d\">\n",$config::basedir,$nextStart;
#	}
	if ($config::webPageUrl ne ""){
	print "<link rel=\"Top\" href=\"${config::webPageUrl}\">\n";
	}
	printf "<link rel=\"Up\" href=\"%sbbs.cgi\">\n",$config::basedir;
	if ($config::useRSS > 0) {
		printf "<link rel=\"alternate\" type=\"application/rss+xml\" title=\"RSS\" href=\"%s\">\n", $config::rssUrl;
	}

	print <<"EOM";
</head>
<body>
<h1>${config::bbsname}</h1>
EOM

	#ʸ
	print "<p class='guide'>\n";
	print "${config::guide}\n";
	print "</p>\n";

	#ޥ
	print "<p class='topCommand'>\n";
	print "<a href=\"${config::basedir}write.cgi\" accesskey=\"W\">񤭹(W)</a> ";
	printf "<a href=\"%sbbs.cgi\" accesskey=\"P\">ڡɽ(P)</a> ",$config::basedir;

	if ($config::webPageUrl ne ""){
		print "<a href=\"${config::webPageUrl}\" accesskey=\"R\">ȥåץڡ(R)</a> ";
	}else{
		print "ȥåץڡ(R) ";
	}
	if ($config::helpPageUrl ne ""){
		print "<a href=\"${config::helpPageUrl}\" accesskey=\"H\">إ(H)</a>";
	}else{
		print "إ(H)";
	}
	print "<br>\n";
	print "</p>\n\n";

	#åɽ
	showSingleThread($permaViewNo , -1);

	if ($config::showPolicy == 1){
		putPolicy();
	}

	#ڡ󥰥
	#print "<p class='navigation'>\n";
	#if ($prevStart > -1) {
	#	printf "<a href=\"%sbbs.cgi?start=%d\" accesskey=\"P\">&lt;&lt; Υڡ(P)</a> ",$config::basedir,$prevStart;
	#}else{
	#	print "&lt;&lt; Υڡ(P) "
	#}

	#printf " <a href=\"%sbbs.cgi\" accesskey=\"T\">ǿΥڡ(T)</a> ",$config::basedir;

	#if ($nextStart > -1) {
	#	printf " <a href=\"%sbbs.cgi?start=%d\" accesskey=\"N\">Υڡ(N) &gt;&gt;</a>",$config::basedir,$nextStart;
	#}else{
	#	print " Υڡ(N)  &gt;&gt;";
	#}
	#print "<br>\n";
	#print "</p>\n\n";

	print <<"EOM";
<form method="POST" action="${config::basedir}admin.cgi" class="adminForm">
<p>
<span class='formDescription'>ѥѥɡ</span><input type="password" name="a">
<input type="submit" value="">
</p>
</form>
EOM
	putFooter();
}

#ǽ񤭹ɤ߹
sub readLatest {
	if (open(FILE,"<data/latest.dat")) {
		#flock(FILE,2);

		my $latest = readline *FILE;

		#flock(FILE,8);
		close(FILE);
		
		return $latest;
	}else{
		return "";
	}
}

#Υڡ
sub putNeedWaitPage {
print "Content-type: text/html;charset=EUC-JP\n";
print "Cache-Control: no-cache\n";
print "Pragma: no-cache\n";
print "X-UA-Compatible: IE=edge\n";
print "\n";

print <<"EOM";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=EUC-JP">
<meta http-equiv="content-script-type" content="text/javascript">
<meta http-equiv="content-style-type" content="text/css">
<meta http-equiv="Content-Language" content="ja">
<title>${config::bbsname}</title>
EOM

if (length($config::stylesheet) > 0){
	printf "<link rel=\"stylesheet\" type=\"text/css\" href=\"%s\" media='screen,tv,projection,print'>\n",$config::stylesheet;
}

if (length($config::handheldCSS) > 0){
	printf "<link rel=\"stylesheet\" type=\"text/css\" href=\"%s\" media='handheld'>\n",$config::handheldCSS;
}

print <<"EOM";
</head>
<body>
<h1>${config::bbsname}</h1>
<p class='explanation'>
ߡ߹äƤޤФ餯Ԥξ塢ľƤ<br>
</p>
EOM

#뤿Υ
print "<p class='navigation'>\n";
print "<a href=\"${config::basedir}bbs.cgi";
if (length($startThread) > 0) {
	print "?start=" . $startThread;
}elsif (length($permaView) > 0) {
	print "?permaview=1&amp;no=" . $permaViewNo;
}
print "\" accesskey=\"R\">ɽ(R)</a>";
print "<br>\n";
print "</p>\n\n";

	putFooter();
}
